package be2;

class TamponCirc {

  public Tache tampon[];
  private int taille;
  private int en, hors, nMess;

public TamponCirc() {
	super();
}

/* Constructeur. cre un tampon de taille lments */
public TamponCirc (int taille) {
   tampon = new Tache[taille];
	this.taille = taille;
//	for (int i=0; i<taille; i++) tampon[i] = new Tache();
	en = 0;
	hors = 0;
	nMess = 0;
  }  

public void affiche() {
	if (!estVide()) {
		for (int i=hors; i!=en; i=(i+1)%taille) {
			Simu.log.append("Tache n" + tampon[i].numero_tache+"\n");
			tampon[i].affiche();
		};
	}
	else
		Simu.log.append("c'est vide !");
}

public synchronized void depose(Tache obj) {
	while (nMess == taille) {    // si plein
	  try {
		wait();                // attends non-plein
	  } catch (InterruptedException e) { ; }
	}
	tampon[en] = obj;
	nMess++;
	en = (en + 1) % taille;
	notify();                // envoie un signal non-vide
  }  

public boolean estVide() {
	return ((this==null) || (nMess==0));
}

public int getTaille() {
	return nMess;
}

public synchronized Tache preleve() {
	while (nMess == 0) {    // si vide
	  try {
		wait();            // attend non-vide
	  } catch (InterruptedException e) {}
	}
	Tache obj = tampon[hors];
	tampon[hors] = null;    // supprime la ref a l'objet
	nMess--;
	hors = (hors + 1) % taille;
	notify();                // envoie un signal non-plein
	return obj;
  }  

public void remplit(int nMess) {
	for (int i=0; i<nMess; i++) tampon[i] = new Tache(i);
	en = nMess;
	hors = 0;
	this.nMess = nMess;
}
}